3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 C= pass it through git-apply
26 p= pass it through git-apply
27 patch-format= format the patch(es) are in
28 reject pass it through git-apply
29 resolvemsg= override error message when patch failure occurs
30 continue continue applying patches after resolving a conflict
31 r,resolved synonyms for --continue
32 skip skip the current patch
33 abort restore the original branch and abort the patching operation.
34 committer-date-is-author-date lie about committer date
35 ignore-date use current timestamp for author date
36 rerere-autoupdate update the index with reused conflict resolution if possible
37 rebasing* (internal use for git-rebase)"
41 prefix=$(git rev-parse --show-prefix)
46 git var GIT_COMMITTER_IDENT >/dev/null ||
47 die "$(gettext "You need to set your committer info first")"
49 if git rev-parse --verify -q HEAD >/dev/null
57 if test '' != "$interactive"
61 if test '' != "$threeway"
67 git rev-parse --sq-quote "$@"
71 echo "$1" >"$dotest/next"
72 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
77 if test -f "$dotest/dirtyindex"
82 if ! test -s "$dotest/abort-safety"
87 abort_safety=$(cat "$dotest/abort-safety")
88 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
93 gettext "You seem to have moved HEAD since the last 'am' failure.
94 Not rewinding to ORIG_HEAD" &&
100 stop_here_user_resolve () {
101 if [ -n "$resolvemsg" ]; then
102 printf '%s\n' "$resolvemsg"
105 eval_gettext "When you have resolved this problem run \"\$cmdline --resolved\".
106 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
107 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
121 gettext "Cannot fall back to three-way merge."; echo
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
131 # First see if the patch records the index info that we can use.
132 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
134 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
135 git write-tree >"$dotest/patch-merge-base+" ||
136 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
138 say Using index info to reconstruct a base tree...
139 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
140 git apply --cached <"$dotest/patch"
142 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
143 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
145 cannot_fallback "$(gettext "Did you hand edit your patch?
146 It does not apply to blobs recorded in its index.")"
149 test -f "$dotest/patch-merge-index" &&
150 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
151 orig_tree=$(cat "$dotest/patch-merge-base") &&
152 rm -fr "$dotest"/patch-merge-* || exit 1
154 say "$(gettext "Falling back to patching base and 3-way merge...")"
156 # This is not so wrong. Depending on which base we picked,
157 # orig_tree may be wildly different from ours, but his_tree
158 # has the same set of wildly different changes in parts the
159 # patch did not touch, so recursive ends up canceling them,
160 # saying that we reverted all those changes.
162 eval GITHEAD_$his_tree='"$FIRSTLINE"'
163 export GITHEAD_$his_tree
164 if test -n "$GIT_QUIET"
166 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
168 git-merge-recursive $orig_tree -- HEAD $his_tree || {
169 git rerere $allow_rerere_autoupdate
170 echo Failed to merge in the changes.
173 unset GITHEAD_$his_tree
177 test $# = 0 || echo >&2 "$@"
184 check_patch_format () {
185 # early return if patch_format was set from the command line
186 if test -n "$patch_format"
191 # we default to mbox format if input is from stdin and for
193 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
199 # otherwise, check the first few lines of the first patch to try
200 # to detect its format
206 "From "* | "From: "*)
209 '# This series applies on GIT commit'*)
210 patch_format=stgit-series
212 "# HG changeset patch")
216 # if the second line is empty and the third is
217 # a From, Author or Date entry, this is very
218 # likely an StGIT patch
220 ,"From: "* | ,"Author: "* | ,"Date: "*)
228 if test -z "$patch_format" &&
233 # This begins with three non-empty lines. Is this a
234 # piece of e-mail a-la RFC2822? Grab all the headers,
235 # discarding the indented remainder of folded lines,
236 # and see if it looks like that they all begin with the
237 # header field names...
239 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
240 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
243 } < "$1" || clean_abort
247 case "$patch_format" in
249 if test -n "$rebasing" || test t = "$keepcr"
255 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
261 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
263 series_dir=`dirname "$1"`
270 set "$@" "$series_dir/$filename"
272 # remove the safety x
274 # remove the arg coming from the first-line comment
276 } < "$series_file" || clean_abort
277 # set the patch format appropriately
279 # now handle the actual StGIT patches
286 this=`expr "$this" + 1`
287 msgnum=`printf "%0${prec}d" $this`
288 # Perl version of StGIT parse_patch. The first nonemptyline
289 # not starting with Author, From or Date is the
290 # subject, and the body starts with the next nonempty
291 # line not starting with Author, From or Date
292 perl -ne 'BEGIN { $subject = 0 }
293 if ($subject > 1) { print ; }
294 elsif (/^\s+$/) { next ; }
295 elsif (/^Author:/) { print s/Author/From/ ; }
296 elsif (/^(From|Date)/) { print ; }
302 print "Subject: ", $_ ;
305 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
307 echo "$this" > "$dotest/last"
312 if test -n "$parse_patch" ; then
313 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
315 clean_abort "$(gettext "Patch format detection failed.")"
322 dotest="$GIT_DIR/rebase-apply"
323 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
324 resolvemsg= resume= scissors= no_inbody_headers=
326 committer_date_is_author_date=
328 allow_rerere_autoupdate=
330 if test "$(git config --bool --get am.keepcr)" = true
347 utf8=t ;; # this is now default
356 -r|--resolved|--continue)
363 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
365 die "$(gettext "-d option is no longer supported. Do not use.")"
368 shift; resolvemsg=$1 ;;
369 --whitespace|--directory)
370 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
372 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
374 shift ; patch_format="$1" ;;
375 --reject|--ignore-whitespace|--ignore-space-change)
376 git_apply_opt="$git_apply_opt $1" ;;
377 --committer-date-is-author-date)
378 committer_date_is_author_date=t ;;
381 --rerere-autoupdate|--no-rerere-autoupdate)
382 allow_rerere_autoupdate="$1" ;;
397 # If the dotest directory exists, but we have finished applying all the
398 # patches in them, clear it out.
399 if test -d "$dotest" &&
400 last=$(cat "$dotest/last") &&
401 next=$(cat "$dotest/next") &&
403 test "$next" -gt "$last"
410 case "$#,$skip$resolved$abort" in
412 # Explicit resume command and we do not have file, so
416 # No file input but without resume parameters; catch
417 # user error to feed us a patch from standard input
418 # when there is already $dotest. This is somewhat
419 # unreliable -- stdin could be /dev/null for example
420 # and the caller did not intend to feed us a patch but
421 # wanted to continue unattended.
428 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
431 case "$skip,$abort" in
433 die "$(gettext "Please make up your mind. --skip or --abort?")"
437 git read-tree --reset -u HEAD HEAD
438 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
440 git update-ref ORIG_HEAD $orig_head
443 if test -f "$dotest/rebasing"
445 exec git rebase --abort
450 git read-tree --reset -u HEAD ORIG_HEAD
456 rm -f "$dotest/dirtyindex"
458 # Make sure we are not given --skip, --resolved, nor --abort
459 test "$skip$resolved$abort" = "" ||
460 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
463 mkdir -p "$dotest" || exit
465 if test -n "$prefix" && test $# != 0
470 test -n "$first" && {
474 if is_absolute_path "$arg"
478 set "$@" "$prefix$arg"
484 check_patch_format "$@"
488 # -i can and must be given when resuming; everything
490 echo " $git_apply_opt" >"$dotest/apply-opt"
491 echo "$threeway" >"$dotest/threeway"
492 echo "$sign" >"$dotest/sign"
493 echo "$utf8" >"$dotest/utf8"
494 echo "$keep" >"$dotest/keep"
495 echo "$keepcr" >"$dotest/keepcr"
496 echo "$scissors" >"$dotest/scissors"
497 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
498 echo "$GIT_QUIET" >"$dotest/quiet"
499 echo 1 >"$dotest/next"
500 if test -n "$rebasing"
502 : >"$dotest/rebasing"
504 : >"$dotest/applying"
505 if test -n "$HAS_HEAD"
507 git update-ref ORIG_HEAD HEAD
509 git update-ref -d ORIG_HEAD >/dev/null 2>&1
518 files=$(git ls-files) ;;
520 files=$(git diff-index --cached --name-only HEAD --) ;;
524 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
525 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
529 if test "$(cat "$dotest/utf8")" = t
535 if test "$(cat "$dotest/keep")" = t
539 case "$(cat "$dotest/keepcr")" in
543 keepcr=--no-keep-cr ;;
545 case "$(cat "$dotest/scissors")" in
547 scissors=--scissors ;;
549 scissors=--no-scissors ;;
551 if test "$(cat "$dotest/no_inbody_headers")" = t
553 no_inbody_headers=--no-inbody-headers
557 if test "$(cat "$dotest/quiet")" = t
561 if test "$(cat "$dotest/threeway")" = t
565 git_apply_opt=$(cat "$dotest/apply-opt")
566 if test "$(cat "$dotest/sign")" = t
568 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
570 s/^/Signed-off-by: /'
576 last=`cat "$dotest/last"`
577 this=`cat "$dotest/next"`
580 this=`expr "$this" + 1`
584 while test "$this" -le "$last"
586 msgnum=`printf "%0${prec}d" $this`
587 next=`expr "$this" + 1`
588 test -f "$dotest/$msgnum" || {
594 # If we are not resuming, parse and extract the patch information
595 # into separate files:
596 # - info records the authorship and title
597 # - msg is the rest of commit log message
598 # - patch is the patch body.
600 # When we are resuming, these files are either already prepared
601 # by the user, or the user can tell us to do so by --resolved flag.
604 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
605 <"$dotest/$msgnum" >"$dotest/info" ||
608 # skip pine's internal folder data
609 sane_grep '^Author: Mail System Internal Data$' \
610 <"$dotest"/info >/dev/null &&
613 test -s "$dotest/patch" || {
614 eval_gettext "Patch is empty. Was it split wrong?
615 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
616 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
619 rm -f "$dotest/original-commit" "$dotest/author-script"
620 if test -f "$dotest/rebasing" &&
621 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
622 -e q "$dotest/$msgnum") &&
623 test "$(git cat-file -t "$commit")" = commit
625 git cat-file commit "$commit" |
626 sed -e '1,/^$/d' >"$dotest/msg-clean"
627 echo "$commit" > "$dotest/original-commit"
628 get_author_ident_from_commit "$commit" > "$dotest/author-script"
631 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
635 git stripspace > "$dotest/msg-clean"
640 if test -f "$dotest/author-script"
642 eval $(cat "$dotest/author-script")
644 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
645 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
646 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
649 if test -z "$GIT_AUTHOR_EMAIL"
651 gettext "Patch does not have a valid e-mail address."; echo
655 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
659 if test '' != "$SIGNOFF"
662 sed -ne '/^Signed-off-by: /p' \
663 "$dotest/msg-clean" |
667 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
668 test '' = "$LAST_SIGNED_OFF_BY" && echo
675 if test -s "$dotest/msg-clean"
677 cat "$dotest/msg-clean"
679 if test '' != "$ADD_SIGNOFF"
683 } >"$dotest/final-commit"
686 case "$resolved$interactive" in
688 # This is used only for interactive view option.
689 git diff-index -p --cached HEAD -- >"$dotest/patch"
695 if test "$interactive" = t
698 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
700 while test "$action" = again
702 gettext "Commit Body is:"; echo
703 echo "--------------------------"
704 cat "$dotest/final-commit"
705 echo "--------------------------"
706 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
707 # in your translation. The program will only accept English
708 # input at this point.
709 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
713 [aA]*) action=yes interactive= ;;
714 [nN]*) action=skip ;;
715 [eE]*) git_editor "$dotest/final-commit"
718 git_pager "$dotest/patch" ;;
726 if test -f "$dotest/final-commit"
728 FIRSTLINE=$(sed 1q "$dotest/final-commit")
733 if test $action = skip
739 if test -x "$GIT_DIR"/hooks/applypatch-msg
741 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
745 say "$(eval_gettext "Applying: \$FIRSTLINE")"
749 # When we are allowed to fall back to 3-way later, don't give
750 # false errors during the initial attempt.
752 if test "$threeway" = t
754 squelch='>/dev/null 2>&1 '
756 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
760 # Resolved means the user did all the hard work, and
761 # we do not have to do any patch application. Just
762 # trust what the user has in the index file and the
765 git diff-index --quiet --cached HEAD -- && {
766 gettext "No changes - did you forget to use 'git add'?
767 If there is nothing left to stage, chances are that something else
768 already introduced the same changes; you might want to skip this patch."; echo
769 stop_here_user_resolve $this
771 unmerged=$(git ls-files -u)
772 if test -n "$unmerged"
774 gettext "You still have unmerged paths in your index
775 did you forget to use 'git add'?"; echo
776 stop_here_user_resolve $this
783 if test $apply_status != 0 && test "$threeway" = t
787 # Applying the patch to an earlier tree and merging the
788 # result may have produced the same tree as ours.
789 git diff-index --quiet --cached HEAD -- && {
790 say "$(gettext "No changes -- Patch already applied.")"
794 # clear apply_status -- we have successfully merged.
798 if test $apply_status != 0
800 eval_gettext 'Patch failed at $msgnum $FIRSTLINE'; echo
801 stop_here_user_resolve $this
804 if test -x "$GIT_DIR"/hooks/pre-applypatch
806 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
809 tree=$(git write-tree) &&
811 if test -n "$ignore_date"
815 parent=$(git rev-parse --verify -q HEAD) ||
816 say >&2 "$(gettext "applying to an empty history")"
818 if test -n "$committer_date_is_author_date"
820 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
821 export GIT_COMMITTER_DATE
823 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
825 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
828 if test -f "$dotest/original-commit"; then
829 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
832 if test -x "$GIT_DIR"/hooks/post-applypatch
834 "$GIT_DIR"/hooks/post-applypatch
840 if test -s "$dotest"/rewritten; then
841 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
842 if test -x "$GIT_DIR"/hooks/post-rewrite; then
843 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten